import { DoCheck, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges, IterableDiffers } from '@angular/core';
import { AbstractControl, ControlValueAccessor, FormBuilder, FormControl, Validator } from '@angular/forms';
import { Observable, Subject } from 'rxjs';
import { MultiSelectSearchFilter } from './search-filter.pipe';
import { IMultiSelectSettings, IMultiSelectTexts } from './types';
import { BaseFilter } from '../../base-filter';
import { FilterItem } from '../../../data-table.bundle';
export declare class SelectFilterComponent extends BaseFilter implements OnInit, OnChanges, DoCheck, OnDestroy, ControlValueAccessor, Validator {
    private element;
    private fb;
    private searchFilter;
    filterControl: FormControl;
    options: Array<FilterItem>;
    settings: IMultiSelectSettings;
    texts: IMultiSelectTexts;
    disabled: boolean;
    disabledSelection: boolean;
    selectionLimitReached: EventEmitter<any>;
    dropdownClosed: EventEmitter<any>;
    dropdownOpened: EventEmitter<any>;
    onAdded: EventEmitter<any>;
    onRemoved: EventEmitter<any>;
    onLazyLoad: EventEmitter<any>;
    onFilter: Observable<string>;
    onClick(target: HTMLElement): void;
    destroyed$: Subject<any>;
    filteredOptions: FilterItem[];
    renderFilteredOptions: FilterItem[];
    model: any[];
    parents: any[];
    title: string;
    differ: any;
    numSelected: number;
    set isVisible(val: boolean);
    get isVisible(): boolean;
    renderItems: boolean;
    checkAllSearchRegister: Set<unknown>;
    checkAllStatus: boolean;
    loadedValueIds: any[];
    defaultSettings: IMultiSelectSettings;
    defaultTexts: IMultiSelectTexts;
    get searchLimit(): number;
    get searchRenderAfter(): number;
    get searchLimitApplied(): boolean;
    private _isVisible;
    private _workerDocClicked;
    constructor(element: ElementRef, fb: FormBuilder, searchFilter: MultiSelectSearchFilter, differs: IterableDiffers);
    getItemStyle(option: FilterItem): any;
    getItemStyleSelectionDisabled(): any;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    updateRenderItems(): void;
    applyFilters(options: any, value: any): FilterItem[];
    onModelChange: Function;
    onModelTouched: Function;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(isDisabled: boolean): void;
    ngDoCheck(): void;
    validate(_c: AbstractControl): {
        [key: string]: any;
    };
    registerOnValidatorChange(_fn: () => void): void;
    clearSearch(event: Event): void;
    toggleDropdown(): void;
    isSelected(option: FilterItem): boolean;
    setSelected(_event: Event, option: FilterItem): void;
    updateNumSelected(): void;
    updateTitle(): void;
    searchFilterApplied(): boolean;
    addChecks(options: any): void;
    checkAll(): void;
    uncheckAll(): void;
    preventCheckboxCheck(event: Event, option: FilterItem): void;
    isCheckboxDisabled(): boolean;
    checkScrollPosition(ev: any): void;
    checkScrollPropagation(ev: any, element: any): void;
    load(): void;
    private _tagTextInput;
    get tagTextInput(): any;
    set tagTextInput(v: any);
}
