import { OnInit, EventEmitter } from '@angular/core';
import { Filter } from '../models/filter';
import { FilterItem } from '../data-table.bundle';
import { InputFilterComponent } from './controls/input-filter.component';
import { DateFilterComponent } from './controls/date-filter.component';
import { BooleanFilterComponent } from './controls/boolean-filter.component';
import { ComboboxSettings, ComboboxStyles, PromiseParameters } from 'cl-angular-combobox';
import { ComboboxComponent } from 'cl-angular-combobox';
import { GenericFilterRepository } from '../repositories/generic-filter-repository';
import { ResponseModel } from 'cl-angular-core';
export declare class DataTableFilterComponent implements OnInit {
    private genericRepository;
    settings: ComboboxSettings;
    comboboxStyle: ComboboxStyles;
    optionsModel: number[];
    onSelectFilterChanged($event: any): void;
    inputFilter: InputFilterComponent;
    dateFilter: DateFilterComponent;
    booleanFilter: BooleanFilterComponent;
    triggerFilterChanged: boolean;
    updateFilters(): any;
    private _filter;
    get filter(): Filter;
    set filter(v: Filter);
    constructor(genericRepository: GenericFilterRepository);
    initializeComboboxSettings(): void;
    ngOnInit(): void;
    onFilterChanged: EventEmitter<any>;
    onSelectionChanged($event: any): void;
    onFilterOperationChanged($event: any): void;
    searchInputChanged(): void;
    filterChanged($event: any): void;
    setFilter(items: FilterItem[], operator?: string): void;
    comboboxPromise: Promise<ResponseModel<any>>;
    createComboboxPromise(promiseLoader?: PromiseParameters): void;
    getPath(input: string): string;
    splitCamel(element: string): string;
    pluralize(element: string): string;
    _combobox: ComboboxComponent;
    set combobox(combobox: ComboboxComponent);
    comboboxItemsLoaded: EventEmitter<any>;
    comboboxPromiseLoaded($event: ResponseModel<any>): FilterItem[];
}
