import { Filter } from './filter';
import { FilterItem } from './filter-item';
import { Condition } from './condition';
import { TypeCondition } from './type-condition';
export declare enum NestedDataStrategy {
    None = 0,
    Concat = 1,
    Divide = 2
}
export declare class Column {
    index: number;
    nestedDataStrategy: NestedDataStrategy;
    concatStrategy: string;
    divisionField: string;
    displayText: string;
    supportsSorting: boolean;
    sortDirection: number;
    filterEnabled: boolean;
    filter: Filter;
    minWidth: string;
    template: string;
    field: string;
    moneyInputValueField: string;
    moneyInputCurrencyIDField: string;
    filterKey: string;
    sortKey: string;
    type: string;
    format: string;
    join: string;
    isComputed: boolean;
    conditions: Condition[];
    isActive: boolean;
    supportsGrouping: boolean;
    grouped: boolean;
    selections: FilterItem[];
    typeConditions: TypeCondition[];
    enableAddon: boolean;
    addonSymbol: string;
    dateMaxValueField: string;
    dateMinValueField: string;
    toggleSort(): void;
    getTemplate(item: any): any;
    extractValue(item: any, field: string, returnLength?: boolean): any;
    actionButtonDisplayText: string;
    static parseList(objects: any): Column[];
    static parse(element: any): Column;
    static getIncludeStrings(columns: Column[]): string[];
}
