interface FilterItemObserver {
    selectedChanged(item: FilterItem): any;
}
declare enum SelectionState {
    Selected = 0,
    PartiallySelected = 1,
    NotSelected = 2
}
export declare class FilterItem implements FilterItemObserver {
    parent?: FilterItem;
    key: string;
    value: any;
    owner?: any;
    data?: any;
    selected?: boolean;
    filterKey?: string;
    enabled: boolean;
    activated?: boolean;
    selectionState: SelectionState;
    readonly: boolean;
    toggleSelection(): void;
    setSelected(value: boolean): void;
    setSelectionState(): void;
    getSelected(): boolean;
    observers: FilterItemObserver[];
    children: FilterItem[];
    isLabel?: boolean;
    isFilter?: boolean;
    parentId?: any;
    params?: any;
    classes?: string;
    childSelectionText: string;
    maxChildDisplayLength: number;
    static parseList(objects: any): FilterItem[];
    static parse(element: any): FilterItem;
    selectedChanged(item: FilterItem): void;
    childSelectionTexts: string[];
    setParentSelectionText(): void;
    setAndObserveChildren(children: FilterItem[]): void;
    addAndObserveChildren(children: FilterItem[]): void;
    refreshSelectionState(): void;
    addAndObserveChild(child: FilterItem): void;
    getSelectedChildren(): FilterItem[];
}
declare global {
    interface Array<T> {
        asFilter(): Array<FilterItem>;
    }
}
declare global {
    interface Array<T> {
        clone(): Array<T>;
    }
}
export {};
